
        INCLUDE \masm32\include\masm32rt.inc
        .586
        INCLUDE \masm32\macros\timers.asm

nVal      = 36
LoopCount = 10

        .CODE

_main   proc

;display the result value

        mov     eax,nVal
        call    fib
        print   ustr$(eax),9,'result value',13,10

;restrict execution to a single core

        INVOKE  GetCurrentProcess
        INVOKE  SetProcessAffinityMask,eax,1

;run timing test 5 times

        INVOKE  Sleep,500
        mov     ecx,5

test00: push    ecx

        counter_begin LoopCount,HIGH_PRIORITY_CLASS

        mov     eax,nVal
        call    fib

        counter_end

        print   ustr$(eax),9,'clock cycles',13,10

        pop     ecx
        dec     ecx
        jnz     test00

;wait for a keypress, then exit

        inkey
        exit

_main   endp

;---------------------------------------------------------------

fib     proc

;Call With: EAX = n
;  Returns: EAX = fib(n)

        cmp     eax,1
        jbe     fib000

        dec     eax
        push    eax
        dec     eax
        call    fib
        push    eax
        mov     eax,[esp+4]
        call    fib
        add     eax,[esp]
        add     esp,8

fib000: ret

fib     endp

;---------------------------------------------------------------

        end     _main

